/* DISARM (sample executable)
 * Simple-minded ARM disassembler
 * (C) Copyright 1999 Kevin F. Quinn, all rights reserved
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*
 *
 * The GNU General Public License is also available on the World Wide Web
 * at http://www.gnu.org/copyleft/gpl.html
 *
 * To contact the author, email kevq@banana.demon.co.uk
 */

#include <stdio.h>
#include "disarm.h"

/* QD Text I/O front-end for disarm */
int main (void)
{
  char line[256];
  RawInstruction rawinst;

#ifdef tryall
  /* This section will call disarm for all values of rawinst, just to make sure it
   * doesn't crash for any value.  This doesn't mean it will return the correct result
   * for every value, but it does show that disarm() is stable.
   * Takes about 5.5 minutes per 0x1000000 values on my PII 266, total just under 24 hours.
   */
  rawinst = 0x0;
  do {
    /* printf("%LX\n", rawinst); fflush(stdout); */
    if ((rawinst & 0xFFFFFF) == 0) { printf("%8.8X\n", rawinst); fflush(stdout); }
    (void) disarm (rawinst);
    rawinst++;
  } while (rawinst != 0);
#else
  printf("Instruction (8 character 32bit hex word):");
  while (!feof(stdin) && (NULL != fgets(line, 256, stdin)))
  {
    if ((1 == sscanf(line, "%lx", &rawinst)) && (9 == strlen(line)))
    {
      printf("%s\n", disarm(rawinst));
      printf("Instruction (8-character 32bit hex word):");
    }
    else
    {
      printf("Huh?  8-character 32bit hex word, please:");
    }
  }
  printf("\n");
#endif
  return (0);
}
